<?php

// dbman_lib.inc.php.inc.php - PHProjekt Version 4.2
// copyright    2000-2004 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther
              
// space for element names which are displayed on the left side before the input element
$text_width=75;

// check whether the lib has been included - authentication!
if (!defined("lib_included")) { die("Please use index.php!"); }
                              
// module name and table name may differ -> here is the translation table  
$tablename['contacts'] = 'contacts';
$tablename['projects'] = 'projekte';
$tablename['notes'] = 'notes';
$tablename['helpdesk'] = 'rts'; 

// download attached file
if ($download_attached_file) download_attached_file($download_attached_file);                                                                       

// fetch all elements of a form, it's properties and the related values if an ID is given                            
function build_array($module, $ID, $mode='forms') {
 global $tablename; 

  // determine whether the list of the form mode is active - and then just fetch those recordds which have a position value > 0
 $mode == 'view' ? $mode2 = 'list_pos' : $mode2 = 'form_pos'; 
                       
// form array for fields
  $result = db_query("select db_name, form_name, form_type, form_tooltip, form_pos, form_regexp, 
                              form_default, form_select, list_pos, filter_show, list_alt, db_table,
                              form_colspan, form_rowspan  
                         from ".DB_PREFIX."db_manager 
                        where db_table like '".$tablename[$module]."' and 
                              ".$mode2." > 0 and
                              db_inactive <> '1'
                     order by ".$mode2) or db_die();                                                            
  while ($row = db_fetch_row($result)) {
    $fields[$row[0]] = array( 'form_name' => $row[1],
                              'form_type' => $row[2],
                              'form_tooltip' => $row[3],
                              'form_pos' => $row[4], 
                              'form_regexp' => $row[5],    
                              'form_default' => $row[6],    
                              'form_select' => $row[7],
                              'list_pos' => $row[8], 
                              'filter_show' => $row[9],    
                              'list_alt' => $row[10],
                              'tablename' => $row[11],
                              'form_colspan' => $row[12],
                              'form_rowspan' => $row[13]);
  }
                                      
  foreach($fields as $field_name => $field_values) { $db_fields[] = $field_name; } 
  // fetch the values of this record - either with a valid ID (>0) or as dummy entries
  if ($ID > 0) {
    $i = 0; 
    $result = db_query("select ".implode(',',$db_fields)."  
                          from ".DB_PREFIX.$tablename[$module]." 
                         where ID = '$ID'") or db_die(); 
    $row = db_fetch_row($result);                  
    if ($row) $row = explode("",html_out(implode("",$row)));
    for($i=0; $i < count($row); $i++) {
      $fields[$db_fields[$i]]['value'] = $row[$i];
    }
  } 
  else {
    for ($i=0; $i < count($db_fields); $i++) {
      $fields[$db_fields[$i]]['value'] = '';    
    }
    // add projectID and contactID
  }     
  return $fields;                       
}     
 
// output of all elements of a form, uses the function form_element to display the different types of form elements like text, textarea  etc.         
function build_form($fields) {
  global $settings;
  
  // include datepicker
  datepicker();
  
  // determine how many rows should be displayed 
  if     ($settings['screen'] > 1250) {$rows = 4; }  
  elseif ($settings['screen'] > 1000) {$rows = 3; }
  else $rows = 2;
  $current_row=1;
              
  echo "<table border=1 rules=cols cellpadding=0 cellspacing=0><tr>";
  foreach($fields as $field_name => $field) {
    form_element($field, $field_name);
    // raise $current_row if we occur a rowspan flag 
    if ($field['form_rowspan'] > 1) {
      $n_rowspan = $field['form_rowspan']-1;
      // remember for lines below this one that we still have a large form element
      if ($field['form_colspan'] > 1) $n_colspan = $field['form_colspan']-1;
    } 
    // usual case: jump to next row  
    if ($field['form_colspan'] > 1) { $current_row = $current_row + $field['form_colspan']-1; }                                                                        
    // new column after this element?
    while ($current_row >= $rows) { 
      echo "</tr><tr>";
      // if there is still  a large object around, 
      if ($n_rowspan > 0) {
        $current_row = $current_row + $n_colspan;
        $n_rowspan--; 
      }
      else {
        $current_row=0;
        $n_rowspan=0; 
        $n_colspan=0;
      }         
    }
    $current_row++;  
  }   
  echo "</tr></table>";
}

// adds the reagexp definition for the javascript check at submission of form
function build_regexp($regexp, $field_name) {
  global $forms_19;
  if ($regexp <> '') { 
    return "onBlur=\"reg_exp('frm','".$field_name."','".$forms_19."',/".$regexp."/)\"";
    }
}

// replaces strings with a dollaras prefix with the value of the variables of the same name
function enable_vars($string) { return preg_replace_callback('#\$(\w+)#si', 'enable_vars2', $string); }
function enable_vars2($varname) { return $GLOBALS[$varname[1]]; }

// foreach defined form element type the html snippet
function form_element($field, $field_name) { 
  global $ID, $quickmail, $read_o, $admin_text64, $text_width, $user_ID, $user_kurz, $sql_user_group,
         $contact_ID, $projekt_ID, $proj_text30, $user_group, $adressen, $projekte, $calltype,
         $img_path, $path_pre, $doc_path, $file_ID, $filter_maxhits, $selected, $module; 
               
  // if it's a new record, give the default value predefined in the db
  if (!$ID) $field['value'] = enable_vars($field['form_default']);

  switch($field['form_type']) {
  
    case 'timestamp_show': 
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td><div";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }      
      echo '>';
      if ($field['value'] <> '') show_iso_date1($field['value']);
      else echo '-';
      echo "</div></td></table></td>\n";      
      break; 
         
    // skip display on creation, onlyshow value at modification
    case 'timestamp_create': 
      if ($ID > 0) {
        echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
        echo enable_vars($field['form_name'])."</td><td><div";
        if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }      
        echo '>'.show_iso_date1($field['value']);
        echo "</div></td></table></td>\n";      
        break; 
      }
      break;       
    case 'timestamp_modify':
      if ($ID > 0) {
        echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
        echo enable_vars($field['form_name'])."</td><td><div";
        if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }      
        echo '>'.show_iso_date1($field['value']);
        echo "</div></td></table></td>\n";     
      }      
      break;      
       
    // display: no chance to edit this, just plain view   
    case 'display':
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td><div";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }      
      echo '>'.$field['value'];
      echo "</div></td></table></td>\n";      
      break;
      
    // display: value taken out of a foreign table via sql   
    case 'display_sql': 
      $result = db_query(enable_vars($field['form_select']));                                                     
      $row = db_fetch_row($result);  
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td><div";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }      
      echo '>'.implode(' ',$row);
      echo "</div></td></table></td>\n";      
      break;       
      
    // text-create means that the user can only insert a text at the time he craetes the record but cannot modify the value later   
    case 'text_create':
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      if (!$ID) {
        echo "<input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
        if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
        echo read_o($read_o)." ".build_regexp($field['regexp'], $field_name).">";
      }
      else echo $field['value'];  
      echo "</td></table></td>\n";       
      break;      
        
    // textarea - no comment  
    case 'textarea':   
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<textarea ".set_size($field)." name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o, 'readonly').">".$field['value']."</textarea>";
      echo "</td></table></td>\n";        
      break; 
      
    // single checkbox - another 'no comment' 
    case 'checkbox':     
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<input type='checkbox' name='".$field_name."' value='yes'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      if ($field['value'] <> '') echo " checked";
      echo read_o($read_o).">\n"; 
      echo "</td></table></td>\n";       
      break;
      
    // range of predefined, fixed values from the field 'form_select'           
    case 'select_values':           
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>';
      foreach(explode('|',$field['form_select']) as $select_value) {
        // split the entry into key and value
        list($key,$value) = explode('#',$select_value);
        if (!$value) $value = $key;
        echo "<option value='".$key."'";
        if ($key == $field['value']) echo " selected";
        echo '>'.enable_vars($value);
      }
      echo "</select></td></table></td>\n";      
      break;
      
    // multiple select        
    case 'select_multiple':           
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select multiple size=".set_size($field)." name='". $field_name."[]'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>'; 
      // move previously selected values into array
      $selected = explode('|',$field['value']);
      foreach(explode('|',$field['form_select']) as $select_value) {
        echo "<option value='".$select_value."'";
        if (in_array($select_value,$selected)) echo " selected";
        echo '>'.$select_value;
      }
      echo "</select></td></table></td>\n";      
      break;     
    
    // fetches the result of a sql statement and displays it in a select box  
    case 'select_sql': 
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>';      
      $result = db_query(enable_vars($field['form_select']));                                                     
      while ($row = db_fetch_row($result)) {                                                                                  
        echo "<option value='".implode(',',$row)."'";
        if (implode(',',$row) == $field['value']) echo " selected";
        echo ">".implode(',',$row);
      }
      echo "</select></td></table></td>\n";      
      break;

    // for any kind of phone operation, kind of call system is set in the config.inc.php
    case 'phone':  
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";  
      if ($ID > 0) echo "<a href=\"javascript:go_phone('".$calltype."','".$field['value']."');\">".enable_vars($field['form_name'])."</a>";
      else echo enable_vars($field['form_name']);
      echo "</td><td><input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o)."></td></table></td>\n";         
      break;     

    // combines the option to select an entry from previous records or to insert a new value
    case 'select_category':   
      // first the previous values
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";                                                                     
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'\n"; }
      echo read_o($read_o)."><option value=''>";
      // define access rule          
      $result = db_query("select distinct ".$field_name." 
                            from ".DB_PREFIX.$field['tablename']."
                           where ".$field_name." <> '' and
                                 von = ".$user_ID."
                        order by ".$field_name) or db_die();
      while ($row = db_fetch_row($result)) {  
        echo "<option value='".$row[0]."'";
        if ($row[0] == $field['value']) echo " selected";
        echo ">".implode(',',$row);
      }
      echo "</select> \n";  
      echo $admin_text64."<input type='text' size=".set_size($field)." name='new_category'\n";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'\n"; }                           
      echo read_o($read_o)."></td></table></td>\n";   
      break;          
    
    case 'upload':                                                                                                     
      list($filename,$tempname) = explode('|',$field['value']);
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";                                                                     
      echo "<input type='file' size=".set_size($field)." name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>';                                                                     
      // link to file and red button to delete this file separately
      if ($filename <> '') {     
        $rnd = rnd_string(9);
        $file_ID[$rnd] = $field['value'];                                                                                               
        echo "<br>(<a href='".$path_pre."/lib/dbman_lib.inc.php?module=$module&download_attached_file=".$rnd.$sid."' target=_blank>$filename</a> \n";        
        if (!$read_o) {
          echo "<a href='$module.php?mode=data&delete_file=1&ID=$ID&file_field_name=".$field_name.$sid."'><img src='".$img_path."/r.gif' height=7 alt='".$delete_it."' border=0></a>)";
        }
      }                                                                                                                                 
      echo "</td></table></td>\n"; 
      
      reg_sess_vars(array("file_ID"));                
      break;
                                                                                                                         
    case 'date': 
      //  take predefined values from global space or set to 'today'
      if ($GLOBALS[$field_name] <> '') { $field['value'] = $GLOBALS[$field_name]; }
      elseif (!$field['value']) { $field['value'] = date("Y-m-d"); }        
      echo "<td".set_span($field)." valign=top><table><td width='$text_width' valign='baseline'>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<input type='text' size=10 name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; } 
			$date_pick = ($read_o)?(""):("&nbsp;<a href='javascript://' onclick='callPick(document.frm.".$field_name.")'><img src='".$img_path."/cal.gif' border=0></a>");
			echo read_o($read_o).">".$date_pick."</td></table></td>\n";       
      break;  

    case 'time':                
      // split time into hours and minutes
      $hour = substr($field['value'],0,2);
      $minute = substr($field['value'],3,5);      
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select name='".$field_name."_hour'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'>';
      // hours
      for($i=0; $i<=23; $i++) {
        if ($i<10) $i = '0'.$i;
        echo "<option value='".$i."'";
        if ($i == $hour) echo " selected";
        echo ">$i\n";
      }
      echo '</select> ';
      // minutes
      echo "<select name='".$field_name."_minute'".read_o($read_o).">";
      for($i=0; $i<=59; $i++) {
        if ($i<10) $i = '0'.$i;
        echo "<option value='".$i."'";
        if ($i == $minute) echo " selected";
        echo ">$i\n";
      }
      echo '</select>';      
      echo "</td></table></td>\n";    
      break;                                                                                        

    // mail address - gives link zu mail reader
    case 'email':  
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      if ($ID > 0) echo "<a href=\"javascript:mailto('email',0,'".(SID?$PHPSESSID:"")."',$quickmail)\">".enable_vars($field['form_name'])."</a>";
      else echo enable_vars($field['form_name']);
      echo "</td><td><input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o)."></td></table></td>\n";   
      break; 
     
    // give the mail adress at creation of record 
    case 'email_create':
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      if ($ID > 0) {
        echo "<a href=\"javascript:mailto('email',0,'".(SID?$PHPSESSID:"")."',$quickmail)\">".enable_vars($field['form_name'])."</a>";
        echo "</td><td>".$field['value'];
      }  
      else {
        echo enable_vars($field['form_name']);
        echo "</td><td><input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
        if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'".read_o($read_o).">"; }
      }
      echo "</td></table></td>\n";          
      break;  
      
    // url - opens address in a new window
    case 'url': 
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      if ($ID > 0) echo "<a href=\"javascript:go_web();\">".enable_vars($field['form_name'])."</a>";
      else echo enable_vars($field['form_name']);
      echo "</td><td><input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o)."></td></table></td>\n";   
      break;
      
    // refers to an entry from the table 'contacts', selectable           
    case 'contact':
    $selected=$contact_ID;
      if ($adressen) {
        // transmit the contact ID if the call comes from a foreign module
        if ($contact_ID > 0) $field['value'] = $contact_ID;  
        echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
        echo enable_vars($field['form_name'])."</td><td>\n";  
           select_contacts($field['value'], 'contact');                
        echo "</td></table></td>\n";
      }
      break;
      
    // select a contact during the creation of the record but only display the value later
    case 'contact_create':
     
      if ($adressen) {
         // transmit the contact ID if the call comes from a foreign module     
        if ($contact_ID > 0) $field['value'] = $contact_ID;
       
        if ($ID > 0) {
          echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
          echo enable_vars($field['form_name'])."</td><td><div";
          if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }      
          echo '>'.slookup('contacts','nachname,vorname','ID',$field['value']);
          echo "</div></td></table></td>\n";
        } 
        else {        
          echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
          echo enable_vars($field['form_name'])."</td><td>\n";  
          select_contacts($field['value'], 'contact');          
          echo "</td></table></td>\n";  
        }
      }           
      break;   
      
    // refers to an entry from the table 'project'           
    case 'project':
      if ($projekte) {
        // transmit the project ID if the call comes from a foreign module     
        if ($projekt_ID > 0) $field['value'] = $projekt_ID; 
        // special hack for forms - if the contact ID is given, mark this one as selected
        $projekt_ID > 0 ? $selected = $projekt_ID : $selected = $field['value'];               
        echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
        echo enable_vars($field['form_name'])."</td><td>\n";
        echo "<select name='". $field_name."'";
        if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
        echo read_o($read_o)."><option value=''>";
        show_elements_of_tree('projekte',
                              'name',
                              "where (von = ".$user_ID." or acc like 'system' or ((acc like 'group' or acc like '%\"$user_kurz\"%') and $sql_user_group))",
                              'acc'," order by name",$selected,'parent',0);  
        echo "</select></td></table></td>\n";      
      }
      break;  
      
    // author ID - store the name of the user which has written the record
    case 'authorID':
      if ($ID > 0) {
        echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
        echo enable_vars($field['form_name'])."</td><td><div";
        if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }      
        echo '>'.slookup('users','nachname,vorname','ID',$field['value']);
        echo "</div></td></table></td>\n";                                                                                                         
      }            
      break;
      
    // handles the access to this field - if the userID equals the content of the given field, the user is able to edit this field, otherwise just display
    case 'userID_access':
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";                                                                         
      echo enable_vars($field['form_name'])."</td><td>\n";  
      // check whether content(field) == userID
      if (slookup($field['tablename'],$field['form_select'],'ID',$ID) == $user_ID) {
        echo "<input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
        if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
        echo read_o($read_o)." ".build_regexp($field['regexp'], $field_name).">";
      }
      else echo $field['value'];  
      echo "</td></table></td>\n";       
      break;       
        
    // user ID - select an user of this group and store the ID     
    case 'userID':   
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      echo "<select name='". $field_name."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o).'><option value=0>';  
      $result = db_query("select ".DB_PREFIX."users.ID,nachname,vorname 
                            from ".DB_PREFIX."users, ".DB_PREFIX."grup_user 
                           where ".DB_PREFIX."users.ID = user_ID and
                                 grup_ID = '$user_group'
                        order by nachname");                                                     
      while ($row = db_fetch_row($result)) {    
        echo "<option value='".$row[0]."'";
        if ($row[0] == $field['value']) echo " selected";
        echo ">".$row[1].",".$row[2]."\n";
      }
      echo "</select></td></table></td>\n";      
      break; 

    // just display the user name     
    case 'user_show':
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>\n";
      if ($field['value'] > 0) {
        echo slookup('users','nachname,vorname','ID',$field['value']);      
      }  
      echo "</td></table></td>\n";    
      break;                                    
    
      // field element 'text' is default
    default:
      echo "<td".set_span($field)." valign=top><table><td width=$text_width>";
      echo enable_vars($field['form_name'])."</td><td>";
      echo " <input type='text' size=".set_size($field)." name='". $field_name."' value='".$field['value']."'";
      if ($field['form_tooltip'] <> '') { echo " title='".$field['form_tooltip']."'"; }
      echo read_o($read_o)." ".build_regexp($field['form_regexp'], $field_name).">\n"; 
      echo "</td></table></td>\n";       
      break;
  }
}                  

// return size of input element - especially if we have a rowspan/colspan > 1                                     
function set_size($field) { 
  global $default_size, $text_width;
  
  if (!$default_size) $default_size1 = 40;
  else $default_size1 = $default_size; 
  if ($field['form_colspan'] > 1) { 
    $default_size1 = $default_size1*$field['form_colspan']+$text_width/4*($field['form_colspan']-1); 
  }
  
  // for some elements we have to calculate another size number for a nice table layout
  switch ($field['form_type']) {
    case 'upload':
      return ($default_size1 - 22);
      break;
    case 'textarea':  
      $hor_size=floor($default_size1*0.7);
      if ($field['form_rowspan'] > 1) { $ver_size = $field['form_rowspan']*2 - 1; }                              
      else $ver_size = 2;
      return 'rows='.$ver_size.' cols='.$hor_size; 
      break;
    case 'select_multiple': 
      if ($field['form_rowspan'] > 1)  { $ver_size = $field['form_rowspan']*2 - 1; }
      else $ver_size = 2;      
      return $ver_size;
      break;
    case 'select_category':
      return ($default_size1 - 20);     
      break;
    default:
      return $default_size1;
      break;  
  }
}

// provides column name as input field
function col_filter($module,$col_name) { 
  global $field_name, $field, $perpage, $page, $bgcolor3, $bgcolor1, $img_path, $f_sort, $sid, $direction, $sort; 
  // offer a select Box
  if ($field['form_type'] == 'select_values') {
    $str = "<form action='".$module.".php' name=".$field_name." method=post>\n";
    $str .= "<select name='keyword'";
    if ($field['form_tooltip'] <> '') { $str .= " title='".$field['form_tooltip']."'"; }
    $str .= read_o($read_o)." onchange='document.".$field_name.".submit()'>";
    // blank value with name of field
    $str.= "<option value=''>".enable_vars($field['form_name']);
    foreach(explode('|',$field['form_select']) as $select_value) {
      // split the entry into key and value
      list($key,$value) = explode('#',$select_value);
      if (!$value) $value = $key;
      $str .= "<option value='".$key."'";
      if ($key == $field['value']) $str .= " selected";
      $str .= '>'.enable_vars($value);
    }  
    $str .= "</select>\n";
  } 
  // otherwise a simple input box
  else {
    $str = "<form action='".$module.".php' name=".$field_name." method=post>\n";
    $str .= "<input style='background-color: $bgcolor3; border: 1px solid $bgcolor1;' type=text size=15 name=keyword value='".enable_vars($field['form_name'])."'";
    if ($field['form_type'] == 'contact' or $field['form_type'] == 'project') { $str .= read_o(1); }     
    else { $str .= "onFocus=\"this.value=''\">"; }
  }  
  $hidden = array('mode'=>'view','filter'=>$field_name,'rule'=>'like','perpage'=>$perpage,'page'=>$page, 'sort' => $sort, 'direction' => $direction);
  if(SID)$hidden['PHPSESSID'] = $PHPSESSID;
  $str .= hidden_fields($hidden);
  // show arrows to sort by this column
  $dirs = array('ASC','DESC');
  foreach($dirs as $dir) { 
    ($sort == $field_name and $direction == $dir) ? $sel = '_sel' : $sel = '';
    $str .= "<a href='".$module.".php?direction=".$dir."&sort=".$field_name."&page=$page&perpage=$perpage".$sid."'><img src='".$img_path."/".$dir.$sel.".gif' border=0></a>\n";
  }  
  $str .= "</form>\n";
  return $str;
}


// ***************
// work on filters
function main_filter($filter,$rule,$keyword,$filter_ID,$module,$firstchar=''){
  global $fields, $flist, $tablename;

  // 1. action: check whether a filter element should be removed
  if (isset($filter_ID)) { unset($flist[$module][$filter_ID]); }
  // 2. action: add the current filter to the filter list
  // 2/a special filter for contacts - select all records where the last name begins with this char
  if ($firstchar <> '') { $flist[$module][] = array(DB_PREFIX.$tablename[$module].".nachname",'begins',$firstchar); }
  // 2/b look for a 'normal filter
  elseif ($keyword) { $flist[$module][] = array($filter,$rule,$keyword); } 
  // 3. action: apply the filter list
  if ($flist[$module]) { 
    $filter_list_text = "FILTER: ";     
    // 3.1 apply the filter
    foreach ($flist[$module] as $key => $p_filter) {
      $where .= " and (";    
      // if the field string is 'all', it has to be looped over all applicable fields
      if ($p_filter[0] == 'all') { $where .= apply_full_filter($p_filter[1],$p_filter[2]); }
      else { $where .= apply_filter($p_filter[0],$p_filter[1],$p_filter[2]); }                                    
      $where .=")";  
    }
  }
  if (!$where) $where = ' and 1=1 ';
  // one result of the whole thing: the where clause for the sql query   
  return $where;
}

function display_filters($module) {
  global $flist, $fields, $action, $perpage, $page_n, $direction, $sort, $where, $sid, $con_text34, $delete_it,
         $tablename;  
  // 3. action: apply the filter list
    
  if ($flist[$module]) {  
    $filter_list_text = "Filter: ";     
    foreach ($flist[$module] as $key => $p_filter) {          
      // first fetch the name
      foreach ($fields as $field_name => $field) { 
        if ($field_name == $p_filter[0]) {
          $filtername = enable_vars($field['form_name']);
        }
      }                                                     
      // klick on link removes the filter
      $filter_list_text .= " (<a href='".$module.".php?mode=view&action=$action&filter_ID=$key&perpage=$perpage&page=$page_n&direction=$direction&sort=$sort".$sid."' title='$delete_it'>".
              $filtername." ".$p_filter[1]." ".$p_filter[2]."</a>)\n";        
    }
  }
  // no filter given? -> only show root entries
  reg_sess_vars(array("flist")); 
  return $filter_list_text; 
}

function apply_filter($field,$rule,$keyword) {  
  switch ($rule) { 
    case "begins":
      $w = "$field like '$keyword%'";
      break; 
    case "ends":
      $w = "$field like '%$keyword'";    
      break;      
    case "exact":
      $w = "$field = '$keyword'";      
      break;       
    case ">":
      $w = "$field > '$keyword'";      
      break;      
    case ">=":
      $w = "$field >= '$keyword'";      
      break;               
    case "<=":
      $w = "$field <= '$keyword'";      
      break;            
    case "<":
      $w = "$field < '$keyword'";     
      break;      
    case "not like":
      $w = "$field not like '%$keyword%'";     
      break;           
    // default rule: like
    default:
      $w = "$field like '%$keyword%'";    
  }
  return $w;
}

function apply_full_filter($rule, $keyword) {
  global $fields;
  
  foreach ($fields as $field_name => $field) {
    if ($field['filter_show'] <> '') { $f_list[] = apply_filter($field_name,$rule,$keyword); }}
  $w = implode(" or ",$f_list); 
  return $w;  
}

// Filter in navigation bar
function nav_filter($fields) {
  global $datei_text14, $rts_23, $rts_22, $filter_like, $filter_exact,$filter_begins,$filter_ends,$filter_bigger1,
         $filter_bigger2,$filter_smaller1,$filter_smaller2,$filter_notlike;
  
  $filter_rules = array('like'=>$filter_like,
                      'exact'=>$filter_exact,
                      'begins'=>$filter_begins,
                      'ends'=>$filter_ends,
                      '>'=>$filter_bigger1,
                      '>='=>$filter_bigger2,
                      '<'=>$filter_smaller1,
                      '<='=>$filter_smaller2,
                      'not like'=>$filter_notlike);    
   
  $str =  "<td>$datei_text14:</td>\n";
  // ... and the filter field
  $str .= "<td><select name='filter'><option value='all'>$rts_23\n";
    
  foreach ($fields as $field_name => $field) {
    if ($field['filter_show'] <> '') { $filter_list[$field_name] = enable_vars($field['form_name']); }
  }  
  // sort array by name
  natcasesort($filter_list); reset($filter_list);
  foreach($filter_list as $filter_field => $filter_formname) {
    $str .= "<option value='".$filter_field ."'";
    if ($filter_field == $filter) { $str .= " selected"; }
    $str .= ">".$filter_formname."\n";
  } 
  // ... rule ... 
  $str .= "</select></td><td><select name='rule'>\n";
  foreach ($filter_rules as $showrule => $ruletext) { $str .= "<option value='$showrule'>$ruletext\n"; }
  $str .= "</select></td>\n";
  $str .= "<td><input type=text size=15 name='keyword'></td><td>$rts_22</td>\n";    
  $str .= "</select></td>\n";
  return $str;                                                                                                                                                      
}
// end filters
// ***********


// if the mail module is installed, then all mailto: links
// should point to this module
function showmail_link($mailadress) {
  global $quickmail, $PHPSESSID;
  if ($quickmail > 0) {
    $str =  "<a href=\"javascript:mailto(0,'$mailadress','".(SID?$PHPSESSID:"")."')\">$mailadress</a>&nbsp;\n";
  }
  else { $str = "<a href='mailto:$mailadress'>$mailadress</a>&nbsp;\n"; }
  return $str;
} 

function buttons($ID,$module) {
  global $arrproj, $sid, $filter, $keyword, $direction, $sort, $page, $perpage, 
         $img_path, $tree_mode, $getstring, $tablename, $children; 
  
  $buttons = 0;
  // if the radio button 'open' was selected: set all main projects to open:
  if ($tree_mode == "open") { $arrproj[$ID] = 1; } 
  if ($children[$ID]) { 
    // show button 'open'
    if (!$arrproj[$ID]) { echo "<a name='A".$row[0]."' href='".$module.".php?mode=view&element_mode=open&ID=$ID&&sort=$sort&direction=$direction&page=$page&perpage=$perpage".$sid."#A$row[0]'><img src='$img_path/close.gif' border=0>&nbsp;</a>"; }
    // show button 'close'
    else { echo "<a name='A".$row[0]."' href='".$module.".php?mode=view&element_mode=close&ID=$ID&sort=$sort&direction=$direction&page=$page&perpage=$perpage".$sid."#A$row[0]'><img src='$img_path/open.gif' border=0>&nbsp;</a>"; }
    $buttons = 1;
  }
  return $buttons;
} 
      
function build_table($addfields, $module, $where) {
  global $page, $perpage, $field_name, $field, $fields, $flist, $tablename, $nr, $children, $row; 

    // table header
    echo "<table border=0 cellpadding=1 cellspacing=1 width='100%'><tr><td width=2%>&nbsp;</td>\n";          
    // fetch the relevant fields to display in list view                                                                 
    foreach($fields as $field_name => $field) { 
      if ($field['list_pos'] > 0) {
        $fieldlist[] = $field_name;
      }
    } 
   
    foreach($fields as $field_name => $field) {
      if ($field['list_pos'] > 0) {
        echo "<td width=".floor(98/count($fieldlist))."%>".col_filter($module,$field_name)."</td>\n";
      }  
    }       
    echo "</tr>\n"; 
        
    // start rows   
    // store the result in two arrays: one contains all records, the other one just the root records (just in case no filter is active) 
    $result = db_query("select ".implode(',',array_merge($addfields,$fieldlist))." from ".DB_PREFIX.$tablename[$module]." where ".$where) or db_die(); 
  while ($row2 = db_fetch_row($result)) {
  $row[$row2[0]] = $row2;
            
    // build array of children
    if ($row2[3] > 0) { $children[$row2[3]][] = $row2[0]; } 
    // depending on tree view or flat view (due to filter setting) add the record to the list                                                                              
    if ((!$flist[$module] <> '' and !$row2[3])) {$mainrecords[] = $row2[0];}
    else { $foundrecords[] = $row2[0]; }         
        }
                                                                                 
  // end of transfer from db, begin output                                                                                                
  (count($row) < ($page+1)*$perpage) ? $maxnr = count($row) : $maxnr = ($page+1)*$perpage;
     $nr_record = $page*$perpage; 
     while ($nr_record < $maxnr) { 
       if (!$flist[$module] and $mainrecords) {
      if ($mainrecords[$nr_record] > 0) list_records($mainrecords[$nr_record], $module, $fieldlist, $fields, $addfields);
       }
       // ... otherwise over the found records according to the filter
       else {
      if ($foundrecords[$nr_record] > 0) list_records($foundrecords[$nr_record], $module, $fieldlist, $fields, $addfields);
       }
       $nr_record++;
     }  
   echo "</table><br>\n";
}

function list_records($ID, $module, $fieldlist, $fields, $addfields) {
  global $level, $arrproj, $img_path, $firstchar, $import, $sort, $direction, $filter, $sid, $m1_text29, $doc_path, $path_pre, 
         $no_value, $flist, $getstring, $nr, $children, $row, $user_ID, $delete_it, $confirm, $datei_text13, $page, $perpage;    
             
    $row[$ID] = explode("",html_out(implode("",$row[$ID]))); 
    // prepares the output of all files/values for the blue button
    foreach ($fields as $field_name => $field) {
      if ($field['list_alt'] == '1') { $string .= enable_vars($field['form_name']).": ".$field['value']."\n"; }
    }
    $sign .= "<a href='".$module.".php?mode=forms&ID=".$ID.$sid."'><img src='$img_path/b.gif' title='".$string."' border=0 width=7 hspace=2></a>";
    // show button for delete record, personal access and modify
    if ($row[$ID][1] == $user_ID) {
      $sign .= "<a href='".$module.".php?mode=data&delete=1&ID=".$ID.$sid."'><img src='$img_path/r.gif' title='$delete_it' border=0 width=7 hspace=2 onClick=\"return confirm('$confirm')\"></a>";                  
      if ($row[$ID][2] == 'private') {
        $sign .= "<img src='$img_path/g.gif' title='$datei_text13' border=0 width=7 hspace=2>";
      }
    }                           
    else {$sign .= "<img src='$img_path/t.gif' border=0 width=22 height=7 hspace=2>"; }  
    // fill main array with values   
    for ($i=0; $i < count($fieldlist); $i++) { $records[$ID][$fieldlist[$i]] = $row[$ID][$i+count($addfields)]; }             
         
         
  $nr++;
  $ref = $module.".php?".$getstring."&mode=forms&ID=$ID&sort=$sort&page=$page&perpage=$perpage&direction=$direction".$sid;
  tr_tag($ref,"",$ID); // draw <tr>
  echo "<td>".$sign."</td>\n";

  // begin row, first cell
      echo "<td>";
      // indent until level in tree  
      for ($i2=1; $i2 <= $level; $i2++) echo "&nbsp;&nbsp;&nbsp;&nbsp;";
  // buttons    
      $buttons = buttons($ID, $module);
      if ($buttons == 0) { echo "&nbsp;&nbsp;&nbsp;&nbsp;"; }
  
      // if this value is blank, add a '[blank]'
  $records[$ID][$fieldlist[0]] ? $first_value = $records[$ID][$fieldlist[0]] : $first_value = '['.$no_value.']';         
      echo "<a href='".$ref."'>".$first_value."</a></td>\n";
                         
  for ($i=1; $i<count($fieldlist); $i++) {                                      
    // mail link
    if ($fields[$fieldlist[$i]]['form_type'] == 'email') {   
      echo "<td>".showmail_link($records[$ID][$fieldlist[$i]])."</td>\n";
    }
    // url link 
    elseif ($fields[$fieldlist[$i]]['form_type'] == 'url') {
      $url = $records[$ID][$fieldlist[$i]]; 
      if ($url <> '' and !ereg("^http",$url) and !ereg("^ftp://",$url)) { $url = "http://".$url; }                         
      echo "<td><a href='".$url."' target=_blank>".$records[$ID][$fieldlist[$i]]."</a></td>\n";
    } 
    // select
    elseif ($fields[$fieldlist[$i]]['form_type'] == 'select_values') { 
      // fetch values from database 
      $values1 = explode('|',$fields[$fieldlist[$i]]['form_select']); 
      $values3 = array();
      // if value and text are different, split them again
      foreach($values1 as $value1){ 
        if (eregi('#',$value1)) { $values2 = explode('#',$value1); }
        else {$values2[0] = $value1; $values2[1] = $value1; }
        $values3[$values2[1]]=$values2[0];
      }    
      echo "<td>".enable_vars(array_search($records[$ID][$fieldlist[$i]],$values3))."</td>\n";
    }      
    // uploaded file
    elseif( $fields[$fieldlist[$i]]['form_type'] == 'upload' ) {
      list($filename,$tempname) = explode('|',$records[$ID][$fieldlist[$i]]);
      echo "<td><a href='".$path_pre.$doc_path."/".$tempname.$sid."' target=_blank>".$filename."</a></td>\n";      
    }
    // link to contact record
    elseif( eregi('contact',$fields[$fieldlist[$i]]['form_type'])) { 
      echo "<td>".slookup('contacts','nachname,vorname,firma','ID',$records[$ID][$fieldlist[$i]])."&nbsp;</td>\n";    
    }
    // link to project record
    elseif( $fields[$fieldlist[$i]]['form_type'] == 'project' ) {
      echo "<td>".slookup('projekte','name','ID',$records[$ID][$fieldlist[$i]])."&nbsp;</td>\n";    
    } 
    // user access - treat it like a normal field
    elseif( eregi('userID_access',$fields[$fieldlist[$i]]['form_type'])) { 
     echo "<td>".$records[$ID][$fieldlist[$i]]."&nbsp;</td>\n"; 
    } 
    // several user short names, serialized    
    elseif( $fields[$fieldlist[$i]]['form_type'] == 'user_ser' ) { 
      $pers_all = ''; 
      $pers =unserialize($records[$ID][$fieldlist[$i]]);
      foreach($pers as $pers2) { $pers_all .= slookup('users','nachname','kurz',$pers2).','; }     
      echo "<td>".$pers_all."&nbsp;</td>\n";      
    }          
    // link to user
    elseif( eregi('user',$fields[$fieldlist[$i]]['form_type'])) { 
      echo "<td>".slookup('users','nachname,vorname','ID',$records[$ID][$fieldlist[$i]])."&nbsp;</td>\n";    
    }    
    // convert timestamps
    elseif( eregi('timestamp',$fields[$fieldlist[$i]]['form_type']) ) {
      echo "<td>".show_iso_date1($records[$ID][$fieldlist[$i]])."&nbsp;</td>\n";    
    }         
    // default action: simply return the value of this field   
    //else { echo "<td>".$records[$ID][$fieldlist[$i]]."&nbsp;</td>\n";
    else { echo "<td>".nl2br($records[$ID][$fieldlist[$i]])."&nbsp;</td>\n"; } 
  }     
  echo "</tr>";
                
  // display children
  if ($arrproj[$ID] and $children[$ID]) {     
    foreach ($children[$ID] as $child) {
        $level++;
      list_records($child, $module, $fieldlist, $fields, $addfields);
        $level--;
      }  
    }
    
} 


// *************
// db operations
// *************

// prepare values for storage in database     
function sqlstrings_create() {
  global $POST_VARS, $fields, $sql_fieldstring, $sql_valuestring, $dbTSnull, $user_ID, $HTTP_POST_FILES;
   foreach($fields as $field_name => $field) {                
    // if the field is an upload form and the user uploaded a file - store the file and return the tempname 
    if ($field['form_type'] == 'upload') {
      if ($HTTP_POST_FILES[$field_name]['tmp_name'] <> '' and $HTTP_POST_FILES[$field_name]['tmp_name'] <> 'none') { $sql_value = upload_file_create($field_name); }
      else { $sql_value = ''; } 
    }    
    elseif($field['form_type'] == 'select_multiple') { 
      $sql_value = store_select_multiple($field_name);       
    }
    elseif($field['form_type'] == 'select_category') {
      if ($POST_VARS['new_category'] <> '') $sql_value = $POST_VARS['new_category'];
      else $sql_value = $POST_VARS[$field_name];
    }
    elseif($field['form_type'] == 'timestamp_modify') {
      $sql_value = $dbTSnull;
    } 
    elseif($field['form_type'] == 'timestamp_create') {
      $sql_value = $dbTSnull;     
    } 
    elseif($field['form_type'] == 'authorID') {
      $sql_value = $user_ID;     
    }           
    elseif($field['form_type'] == 'time') {     
      $hour = $field_name.'_hour'; 
      $minute = $field_name.'_minute';      
      if (strlen($POST_VARS["$hour"]) == 1) $POST_VARS["$hour"] = '0'.$POST_VARS["$hour"];      
      if (strlen($POST_VARS["$minute"]) == 1) $POST_VARS["$minute"] = '0'.$POST_VARS["$minute"]; 
      $sql_value = $POST_VARS["$hour"].":".$POST_VARS["$minute"];     
    }                       
    // in all other cases simply store the value of the field
    else $sql_value = $POST_VARS[$field_name];
    
    // store the name and the value - except for the simple 'display' function
    if($field['form_type'] <> 'display') {
      $sql_fields[] = $field_name;
      $sql_values[] = $sql_value; 
    }
  }
  $sql_fieldstring = implode(",",$sql_fields);
  $sql_valuestring = "'".implode("','",$sql_values)."'";
}
                                                                                                                                                                  
function sqlstrings_modify() { 
  global $POST_VARS, $fields, $dbTSnull, $HTTP_POST_FILES, $user_ID, $ID, $module;
                                 
  foreach($fields as $field_name => $field) {  
    // if the field is an upload form and the user uploaded a file - store the file and return the tempname 
    if ($field['form_type'] == 'upload') {      
      if ($HTTP_POST_FILES[$field_name]['tmp_name'] <> '' and $HTTP_POST_FILES[$field_name]['tmp_name'] <> 'none') { 
       $sql_string .= $field_name." = '".upload_file_modify($field_name, $ID, $module)."',";   
      }
    } 
    // fields with value 'display' will not be filled
    elseif($field['form_type'] == 'display') {}     
    elseif($field['form_type'] == 'select_multiple') {  
      $sql_string .= $field_name." = '".store_select_multiple($field_name)."',";      
    }
    elseif($field['form_type'] == 'select_category') {
      if ($POST_VARS['new_category'] <> '') $sql_string .= $field_name." = '".$POST_VARS['new_category']."',";
      else $sql_string .= $field_name." = '".$POST_VARS[$field_name]."',"; 
    }
    // skip any field with type = create since this value shouldn't be touched anymore
    elseif(eregi('create',$field['form_type'])) {} 
    
    elseif(eregi('userID_access',$field['form_type'])) { 
      if (slookup($field['tablename'],$field['form_select'],'ID',$ID) == $user_ID) {
        $sql_string .= $field_name." = '".$POST_VARS[$field_name]."',"; 
      }
      else {}
    }    
    // timestamp ...    
    elseif($field['form_type'] == 'timestamp_modify') {
      $sql_string .= $field_name." = '".$dbTSnull."',";
    } 
    elseif($field['form_type'] == 'time') {   
      $hour = $field_name.'_hour'; 
      $minute = $field_name.'_minute';      
      if (strlen($POST_VARS["$hour"]) == 1) $POST_VARS["$hour"] = '0'.$POST_VARS["$hour"];      
      if (strlen($POST_VARS["$minute"]) == 1) $POST_VARS["$minute"] = '0'.$POST_VARS["$minute"];    
      $sql_string .= $field_name." = '".$POST_VARS["$hour"].":".$POST_VARS["$minute"]."',";
    }
    // in all other cases simply store the value of the field
    else $sql_string .= $field_name." = '".$POST_VARS[$field_name]."',";
  }   
  return $sql_string;
}

// return string with results for 'select multiple'
function store_select_multiple($field) {
  global $POST_VARS; 
  if ($POST_VARS[$field] <> '') return implode('|',$POST_VARS[$field]);
}

// define size of element and probably colspan /rowspan
function set_span($field) { 
  if ($field['form_rowspan'] > 1) {
    $rows = $field['form_rowspan'];
    $size = " rowspan=$rows";  
  }
  if ($field['form_colspan'] > 1) {
    $cols = $field['form_colspan'];  
    $size .= " colspan=$cols";
  }
  return $size;
} 
               
// ***********
// functions to upload, modify and delete a file in the form 
function upload_file_create($field_name) {  
                             
  global $HTTP_POST_FILES, $tablename, $path_pre, $doc_path; 
  // add extension to random name
  $tempname = rnd_string().strstr($HTTP_POST_FILES[$field_name]['name'],'.');
  // write file      
  copy($HTTP_POST_FILES[$field_name]['tmp_name'],$path_pre.'/'.$doc_path.'/'.$tempname);
  // since only one field as available we have to store both values together
    return $HTTP_POST_FILES[$field_name]['name'].'|'.$tempname;
  }

function upload_file_delete($field_name, $ID, $module) {
  global $tablename;
  // fetch tempname from db
  $result = db_query("select $field_name 
                        from ".DB_PREFIX.$tablename[$module]." 
                       where ID = '$ID'") or db_die();
  $row = db_fetch_row($result); 
  // is there any previous file listed?
  if ($row[0] <> '') {     
    list(,$t2) = explode('|',$row[0]);    
    if (is_file('../docs/'.$t2)) unlink('../docs/'.$t2);
  }
}

function upload_file_modify($field_name, $ID, $module) { 
  // 1. step: delete the old file
  upload_file_delete($field_name, $ID, $module); 
  // 2. step
  return upload_file_create($field_name);
}

// delete a file attached to a record but leave the record as it is
function delete_attached_file ($field_name, $ID, $module) {       
  global $tablename;
  // 1. step: unlink the file
  upload_file_delete($field_name, $ID, $module);   
  // 2. step: update record
  $result = db_query("update ".DB_PREFIX.$tablename[$module]." 
                         set $field_name = '' 
                       where ID = '$ID'") or db_die();  
}                                                                                                                                          

function download_attached_file($rnd) {
  global $tablename, $path_pre, $doc_path, $name, $file_ID;
  $arr = explode("|",$file_ID[$rnd]);

  // Prevent escaping from the attach dir
  if ((ereg('/', $arr[1])) or (ereg('^\.+$', $arr[1]))) { die("You are not allowed to do this!");  }

  // assign the filename
  $name = $arr[0];

  // have a look whether this file exists
  if (!file_exists($path_pre.$doc_path."/".$arr[1])) { die("panic! specified file not found ..."); }

  // include content type definition
  $include_path = $path_pre."lib/get_contenttype.inc.php";
  include_once $include_path;

  // stream the file
  readfile($path_pre.$doc_path."/".$arr[1]);  
} 
// end file operations
// ****************    

function sort_mode($default_column) {                                                                                                                
  global $module, $f_sort, $f_sort_store; 
  if ($_GET['sort']) { 
    $f_sort[$module]['sort'] = $_GET['sort']; 
    $f_sort[$module]['direction'] = $_GET['direction'];
  }  
  elseif ($_SESSION['f_sort'][$module]['sort'] <> '') {  
    $f_sort[$module]['sort'] = $_SESSION['f_sort'][$module]['sort']; 
    $f_sort[$module]['direction'] = $_SESSION['f_sort'][$module]['direction'];
  } 
  elseif ($f_sort_store[$module]['sort'] <> '') {
    $f_sort[$module]['sort'] = $f_sort_store[$module]['sort']; 
    $f_sort[$module]['direction'] = $f_sort_store[$module]['direction'];
  }    
  elseif (!$f_sort[$module]['sort']) {
    $f_sort[$module]['sort'] = $default_column; 
    $f_sort[$module]['direction'] = 'ASC'; 
  }                                                        
 reg_sess_vars("f_sort");
}

// provides sql string to order result sets
function sort_string() {
  global $f_sort, $module;
  if ($f_sort[$module]['sort'] <> '') { return "order by ".$f_sort[$module]['sort']." ".$f_sort[$module]['direction']; }
} 

?>
