<?php

// export.php - PHProjekt Version 4.2
// copyright    2000-2004 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther, Norbert Ku:ck

$path_pre="../";
$include_path = $path_pre."lib/lib.inc.php";
include_once $include_path;

if (!$medium) { die("<html><body>Please select an export format</body></html>!"); }
  switch ($file){
    case "timecard":
      $fields = array("datum",     "anfang",   "ende"   );
      $f_lang = array($datei_text6,$proj_start,$proj_end);       
      $query = "select ".implode(",",$fields)." 
                  from ".DB_PREFIX."timecard 
                 where users = '$user_ID' and 
                       datum like '%-$month-%' and 
                       datum like '$year-%' 
              order by datum";
      $export_array = make_export_array($query);
      break;
       
    case "timecard_admin":
      check_admin_perm();
      $fields = array("datum",     "anfang",   "ende"   );
      $f_lang = array($datei_text6,$proj_start,$proj_end);                
      $query = "select ".implode(",",$fields)." 
                  from ".DB_PREFIX."timecard 
                 where users = '$pers_ID' and 
                       datum like '%-$month-%' and 
                       datum like '$year-%' 
              order by datum";
      $export_array = make_export_array($query);
    break;
    
    case "users":
      $fields = array("anrede",    "vorname",  "nachname",  "kurz",   "firma",    "email","tel1",        "tel2", "fax", "strasse", "plz",       "stadt",     "land"   );
      $f_lang = array($info_text17,$info_text9,$info_text10,$m1_text27,$m1_text28,"Email",$m1_text29."1",$m1_text29."2",$m1_text31,$admin_text26,$info_text13,$info_text14);     
      $query = "select ".implode(",",$fields)."
                  from ".DB_PREFIX."users 
                 where $sql_user_group                                                                                
              order by nachname";
      $export_array = make_export_array($query);
      break;
                                                                                                                              
    case "contacts": 
      $tablename['contacts'] = 'contacts'; 
      if ($firstchar <> "") { $where = "and nachname like '$firstchar%'"; }                                              
      elseif ($keyword) {
         if ($filter == "all" or $filter == '') { $where = "and (nachname like '%$keyword%' or firma like '%$keyword%' or email like '%$keyword%' or stadt like '%$keyword%' or land like '%$keyword%' or kategorie like '%$keyword%' or bemerkung like '%$keyword%')"; }
         else { $where = "and $filter like '%$keyword%'"; }
      }   
      require_once($path_pre.'lib/dbman_lib.inc.php');
      $fields = build_array('contacts', $ID, $mode);
      foreach($fields as $field_name => $field) {  
        $fields2[] = $field_name; 
        $f_lang[] = enable_vars($field['form_name']); 
      }
      $query = "select ".implode(",",$fields2)." 
                  from ".DB_PREFIX."contacts
                 where (acc_read like 'system' or ((von = $user_ID or acc_read like 'group' or acc_read like '%\"$user_kurz\"%') and $sql_user_group))
                       $where 
              order by nachname";

      $export_array = make_export_array($query);
      break;
      
    case "projects":                                           
      $tablename['projects'] = 'projekte';                                           
      if ($keyword) {
         if ($filter == "all" or $filter == '') { $where = "and (name like '%$keyword%' or ende like '%$keyword%' or anfang like '%$keyword%')"; }
         else { $where = "and $filter like '%$keyword%'"; }
      }   
      require_once($path_pre.'lib/dbman_lib.inc.php');
      $fields = build_array('projects', $ID, 'view');
      foreach($fields as $field_name => $field) {
        $fields2[] = $field_name; 
        $na = enable_vars($field['form_name']); 
       if($medium=="xml")$na=str_replace("[%]","",$na);
      /**  if(eregi("[",$na)){
        	
        	$na_t = explode("[",$na);
        	$na= $na_T[0];
        }*/
        $f_lang[] =$na;
      }
     $query = "select ID, ".implode(",",$fields2)." 
                  from ".DB_PREFIX."projekte
                 where (acc like 'system' or ((von = $user_ID or acc like 'group' or acc like '%\"$user_kurz\"%') and $sql_user_group))
                       $where";

      $export_array = make_export_array_projects($query,0);
      break;      
       
    case "bookmarks":
      $fields = array("url","bezeichnung","bemerkung");
      $f_lang = array("url",$m1_text35,   $m1_text36);        
      $query = "select ".implode(",",$fields)." 
                  from ".DB_PREFIX."lesezeichen 
                 where gruppe = $user_group
              order by bezeichnung";
      $export_array = make_export_array($query);
      break; 
      
    case "timeproj":
      $fields = array(DB_PREFIX.'timeproj.datum',DB_PREFIX.'projekte.name',DB_PREFIX.'timeproj.h',DB_PREFIX.'timeproj.m',DB_PREFIX.'timeproj.note');
      $f_lang = array(           $info_text2,                  $proj_name,            $proj_time2,            $rem_text2,           $info_text7);        
      $query = "select ".implode(",",$fields)." 
                  from ".DB_PREFIX."timeproj, ".DB_PREFIX."projekte 
                 where ".DB_PREFIX."timeproj.projekt = ".DB_PREFIX."projekte.ID and 
                       ".DB_PREFIX."timeproj.users = $user_ID and 
                       ".DB_PREFIX."timeproj.datum like '$year-$month-%'
              order by ".DB_PREFIX."timeproj.datum asc";
      $export_array = make_export_array($query);                
      break;
      
    case "project_stat":
      if ($userlist and $projectlist) { 
        foreach ($userlist as $person) {
          foreach ($projectlist as $project) { 
            $fields = array(DB_PREFIX.'users.vorname',DB_PREFIX.'users.nachname',DB_PREFIX.'projekte.name',DB_PREFIX.'timeproj.datum',DB_PREFIX.'timeproj.h',DB_PREFIX.'timeproj.m',DB_PREFIX.'timeproj.note');
            $f_lang = array(           $info_text9,              $info_text10,                 $proj_name,                $info_text2,           $proj_time2,           $rem_text2,            $info_text7);      
            $query = "select ".implode(",",$fields)." 
                        from ".DB_PREFIX."users, ".DB_PREFIX."projekte, ".DB_PREFIX."timeproj 
                       where ".DB_PREFIX."timeproj.projekt = ".DB_PREFIX."projekte.ID and 
                             ".DB_PREFIX."timeproj.users = ".DB_PREFIX."users.ID and 
                             ".DB_PREFIX."timeproj.projekt = '$project' and 
                             ".DB_PREFIX."timeproj.users = '$person' and  
                             ".DB_PREFIX."timeproj.datum >= '$anfang' and 
                             ".DB_PREFIX."timeproj.datum <= '$ende' 
                    order by ".DB_PREFIX."timeproj.datum";
            $export_array = array_merge($export_array, make_export_array($query)); 
          }
        }
      }  
      break;
    
    case 'todo':
      $fields = array("remark","note",     "deadline","anfang",   "priority","progress",);
      $f_lang = array($todo_text6,$todo_text5,$rts_18, $info_text7,$r_proj2,  $proj_start,$rts_38,   $todo_text4);
       $query = "select A.nachname as from_nachname, B.nachname as to_nachname, ".implode(",",$fields)." 
                  from ".DB_PREFIX."todo, ".DB_PREFIX."users as A
             left join ".DB_PREFIX."users as B on B.nachname = ext
                 where (".DB_PREFIX."todo.acc like 'system' or ((von = $user_ID or ext = $user_ID or 
                        ".DB_PREFIX."todo.acc like 'group' or ".DB_PREFIX."todo.acc like '%\"$user_kurz\"%') and 
                        ".DB_PREFIX."todo.gruppe = $user_group)) and                                                
                        A.ID = ".DB_PREFIX."todo.von
              order by deadline desc";                                                                               

      $export_array = make_export_array($query);          
      break; 
      
    case "notes":                                                                                                    
      $fields = array(DB_PREFIX.'notes.name','bemerkung',DB_PREFIX.'notes.kategorie',DB_PREFIX.'notes.div1',DB_PREFIX.'notes.div2');
      $f_lang = array($m1_text35,             $m1_text36,$admin_text70,$notes_text2,          $notes_text3,$proj_text12,$o_projects);        
      $query = "select ".implode(",",$fields).",
                       A.nachname,B.name  
                  from ".DB_PREFIX."notes
             left join ".DB_PREFIX."contacts as A on A.ID = ".DB_PREFIX."notes.contact 
             left join ".DB_PREFIX."projekte as B on B.ID = ".DB_PREFIX."notes.projekt
                 where (".DB_PREFIX."notes.acc like 'system' or ((".DB_PREFIX."notes.von = $user_ID or ".DB_PREFIX."notes.acc like 'group' or ".DB_PREFIX."notes.acc like '%\"$user_kurz\"%') and ".DB_PREFIX."notes.gruppe = $user_group))
              order by ".DB_PREFIX."notes.name";
      $export_array = make_export_array($query);
      // replace the date strings like 20040101142000 with 2004-01-01 14:20
      for ($i=0; $i < count($export_array); $i++) {
        $export_array[$i][3] = show_iso_date1($export_array[$i][3]);
        $export_array[$i][4] = show_iso_date1($export_array[$i][4]);        
      }
      break;    
          
    case 'filemanager':
      die('sorry, no file export available!');     
                                                                                                                                         
    default:
      die("You are not allowed to do this!");     
  }

// **********  
// set header  
// print and html should be shown inline, the rest delivered as attachment 
if (ereg("html|print",$medium)) { 
  $file_download_type = "inline";
  $name = $file.".html"; 
} 
else { 
  $name = $file.".".$medium; 
  $file_download_type = "attachment"; 
}
$include_path = $path_pre."lib/get_contenttype.inc.php";
include_once $include_path; 
// end set header

switch ($medium) {

  // **********
  // pdf output
  case "pdf":
    $table = array();
            
    if (   !is_file($path_pre.'lib/pdf/class.ezpdf.php')) { die("Panic - cannot find the required pdf classes! Read the faq_install.html for the required steps to install this library or disable the pdf support in the config or choose another export format"); }
    else { include ($path_pre.'lib/pdf/class.ezpdf.php'); }    
    $pdf = new Cezpdf('A4','landscape');
      
    $pdf->selectFont(getcwd().'/'.$path_pre.'lib/pdf/fonts/Helvetica');   
        
    foreach ($export_array as $line) {
      $line2 = array();
      for ($i=0;$i < count($line); $i++) {
        $line2[$f_lang[$i]] = $line[$i]; 
      }
      $table[] = $line2;
    }
    $pdf->ezTable($table,'','PHProjekt export file',array('fontSize'=>8));
    $pdf->ezStream(); 
  break;
  
  // ************
  // chart output
  // ************
   
  case "chart":
  break;
  
  // **********
  // xml output
  case "xml":
    $xmlstring = "<?xml version=\"1.0\"?>\n";
    $xmlstring .= "<table>\n";
    if ($export_array) {    
      foreach ($export_array as $line) {
        $xmlstring .= "  <record>\n";  
        for ($i=0;$i < count($line); $i++) {  
          $xmlstring .= "    <".$f_lang[$i].">".$line[$i]."</".$f_lang[$i].">\n";
        }
        $xmlstring .= "  </record>\n";    
      }
    }  
    $xmlstring .= "</table>";
    echo $xmlstring;
  break;
  
   // **********
  // rtf output
  case "rtf":
    $rtfstring = "{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang2055{\\fonttbl{\\f0\fnil\\fcharset0 Helvetica;}}\n";
    $rtfstring .= "\\viewkind4\\uc1\\pard\\f0\\fs20";
    // first the header ...
    for ($i=0; $i<count($f_lang)-1;$i++) { 
      $rtfstring .= "\\b $f_lang[$i]\\b0\\tab";      
    }
    $i++;
    $rtfstring .= "\\b $f_lang[$i]\\b0\\par\n";    
    
    // now the content
    foreach ($export_array as $line) {
      for ($i=0;$i < count($line)-1; $i++) {  
        $rtfstring .= " $line[$i] \\tab";
      }
      $i++;
      $rtfstring .= " $line[$i]\\par\n";
    }
    $rtfstring .="}";
    echo $rtfstring;
  break; 
  
   // **********
  // doc output - same as rtf, but only theheader is slightly different :-)
  case "doc":
    $rtfstring = "{\\rtf1\\ansi\\ansicpg1252\\deff0\\deflang2055{\\fonttbl{\\f0\fnil\\fcharset0 Helvetica;}}\n";
    $rtfstring .= "\\viewkind4\\uc1\\pard\\f0\\fs20";
    // first the header ...
    for ($i=0; $i<count($f_lang)-1;$i++) { 
      $rtfstring .= "\\b $f_lang[$i]\\b0\\tab";      
    }
    $i++;
    $rtfstring .= "\\b $f_lang[$i]\\b0\\par\n";    
    
    // now the content
    foreach ($export_array as $line) {
      for ($i=0;$i < count($line)-1; $i++) {     
        if (!$line[$i]) $line[$i] = " ";
        $rtfstring .= " $line[$i]\\tab";
      }
      $i++; 
      if (!$line[$i]) $line[$i] = " ";
      $rtfstring .= " $line[$i]\\par\n";
    }
    $rtfstring .="}";
    echo $rtfstring;
  break;   
  
  // ****************
  // normal print page
  case "print":
  // begin body of html page and table
  echo "<html><body bgcolor=ffffff onLoad='self.print()'><table border=1 cellpadding=1 cellspacing=0>\n";
  // first put the colums
  echo "<tr>";
  for ($i=0; $i<count($f_lang);$i++) { echo "<td>$f_lang[$i]</td>\n"; }
  echo "</tr>\n";
  // now the content
  foreach ($export_array as $line) {
    echo "<tr>\n";
    foreach ($line as $element) {
      echo "<td>$element&nbsp;</td>";
    }
    echo "</tr>\n";
  }
  // end of table and html page
  echo "</table></body></html>";
  break;
  
  // ***********************
  // xls export - very similar to csv
  case "xls":
    // begin file
    $xlsstring = pack( "ssssss", 0x809, 0x08, 0x00,0x10, 0x0, 0x0 );
    // write 1. line = field names
    for ($i=0; $i<count($f_lang);$i++) { 
      $xlsstring .= pack( "s*", 0x0204, 8+strlen($f_lang[$i]), 0, $i, 0x00, strlen($f_lang[$i]) );
      $xlsstring .= $f_lang[$i];      
    }
    // write content  
    $a=0;
    foreach ($export_array as $line) {
      for ($i=0;$i < count($line); $i++) {
        // special patch for xl since it doesn't understand \r as the line ende
        $line[$i] = str_replace("\r", "", $line[$i]);
        $xlsstring .= pack( "s*", 0x0204, 8+strlen($line[$i]), $a+1, $i, 0x00, strlen($line[$i]) );
        $xlsstring .= $line[$i];
      }
      $a++;
    }
    $xlsstring .= pack("ss", 0x0A, 0x00);
    echo $xlsstring;
    break;  
    
  // ***********************
  // html - similar to print page
  case "html":
    // begin body of html page and table
    echo "<html><body bgcolor=$bgcolor3><table border=1 cellpadding=1 cellspacing=0>\n";
    // first put the colums
    echo "<tr bgcolor=$bgcolor2>";
    for ($i=0; $i<count($f_lang);$i++) { echo "<td><b>$f_lang[$i]</b></td>\n"; }
    echo "</tr>\n";
    // now the content
    if ($export_array) { 
      foreach ($export_array as $line) {
        // alternate bgcolor
        if (($cnr/2) == round($cnr/2)) { $color = "$bgcolor1"; $cnr++;}
        else { $color = "$bgcolor2"; $cnr++; }
        echo "<tr bgcolor=$color>\n";
          foreach ($line as $element) {
          echo "<td>$element&nbsp;</td>";
        }
        echo "</tr>\n";
      }  
    }
    // end of table and html page
    echo "</table></body></html>";
    break;     

  // ***********************
  // default case: csv export
  default:
    foreach ($export_array as $line) { 
       foreach ($line as $element) {
        /* 
        if (ereg(":{",$element)) {
          $element = unserialize($element);
          $element = implode(":", $element);
        }*/
        // delete end of lines in data
        $element = rtrim(eregi_replace("\n|\r"," ",$element));
        
        // mask doublequotes in data for reimport
        $element = ereg_replace('"','""',$element);
        echo "\"$element\"";
        if ( $i < (count($line)-1) ) { echo ","; $i++; }
        else { echo "\n";  $i = 0; }
        
      }
    }
    break; 
}  


// check whether this admin has the permission to export the timecard from this user
function check_admin_perm() {
  global $user_group, $user_access, $groups, $pers_ID;

  // 1. check: is this user an admin?
  if (!ereg("a",$user_access)) { die("you are not allowed to do this!"); }

  // 2. check for the right group - only if it is a group admin
  if ($groups and $user_group > 0) {
    // loop over all groups where the mentioned user is member
    $result = db_query("select grup_ID 
                          from ".DB_PREFIX."grup_user 
                         where user_ID = '$pers_ID'") or db_die();
    while ($row = db_fetch_row($result)) {
      // one entry matches the group of the admin? -> fine :-)
      if ($row[0] == $user_group) { $ok = 1; }
    }
    // no entry found -> die ...
    if (!$ok) { die("you are not allowed to do this!"); }
  }
}

function make_export_array($query) {
  $result = db_query($query) or db_die();
  while ($row = db_fetch_row($result)) { 
    $line = array();
    foreach($row as $element) { $line[] = $element; }
    $export_array[] = $line;
  } 
  return $export_array;
}

function make_export_array_projects($query,$parent) {
  global $export_array, $fields2, $proj_text20, $proj_text21, $proj_text23, $proj_text24, $proj_text25, $proj_text26, $proj_text27; 
  $categories = array( "1" => "$proj_text20", "2" => "$proj_text21", "3" => "$proj_text23", "4" => "$proj_text24",
                     "5" => "$proj_text25", "6" => "$proj_text26", "7" => "$proj_text27");  
  
    
  $result = db_query($query." and parent = '$parent' order by name") or db_die();
  while ($row = db_fetch_row($result)) { 
    $line = array(); 
    $i = -1;
    
    foreach($row as $element) {
    	if($i>=0){
      $element2 = '';
      //patch for project leader
      if ($fields2[$i] == 'chef') {  $element2 = slookup('users','nachname','ID',$element); }
      elseif ($fields2[$i] == 'personen') { 
        $persons = unserialize($element);
        foreach($persons as $pers) $element2 .= slookup('users','nachname','kurz',$pers).',';
      } 
      elseif ($fields2[$i] == 'kategorie') $element2 = $categories[$element];
      else $element2 = $element;  
      $line[] = $element2; 
     }
      $i++;
    }
    $export_array[] = $line;
    make_export_array_projects($query,$row[0]);
  } 
  return $export_array;
}

?>
