<?php

// projects_forms.php - PHProjekt Version 4.2
// copyright    2000-2004 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther

// check whether the lib has been included - authentication!
if (!defined("lib_included")) { die("Please use index.php!"); }
                                                                                                                     
// check role
if (check_role("projects") < 1) { die("You are not allowed to do this!"); } 
   
include_once("$lib_path/access_form.inc.php");                                                                                                                                     

                                                                                                                               
echo set_page_header();                                                                                                                 
       
// update project? -> fetch values form record
if ($action <> "new" and $ID > 0) { 
  $result = db_query("select ID, name, anfang, ende, chef, contact, stundensatz, budget, wichtung, 
                             ziel, note, depend_mode, depend_proj, next_mode, next_proj, probability, 
                             ende_real, kategorie, status, statuseintrag, parent, personen, acc, acc_write, von
                        from ".DB_PREFIX."projekte 
                       where (acc like 'system' or ((von = $user_ID or acc like 'group' or acc like '%\"$user_kurz\"%') and $sql_user_group)) and
                             ID = '$ID'") or db_die();
  $row = db_fetch_row($result);
  // check access
  // genreal acces - either the user has direct access to it or the user has chief status
  if (!$row[0]) { die("You are not privileged to do this!"); }      
  if (($row[24] <> $user_ID and $row[23] <> 'w') or check_role("projects") < 2) { $read_o = 1; }    
  
  // get values
  $project_name = html_out($row[1]);
  $anfang = $row[2];
  $ende = $row[3];
  $chef   = $row[4];
  $contact = $row[5];
  $stundensatz = $row[6];
  $budget = $row[7];
  $wichtung = $row[8];
  $ziel = $row[9];
  $note = $row[10];
  $depend_mode = $row[11];
  $depend_proj = $row[12];
  $next_mode = $row[13];
  $next_proj = $row[14];  
  $probability = $row[15];
  $ende_real = $row[16]; 
  $category = $row[17];
  $status = $row[18];
  $statuseintrag = $row[19]; 
  $parent = $row[20];
  $acc = $row[22];
  $acc_write = $row[23]; 
}

  // set variables for a new project:
  else {
    // new subproject ...
    if ($parent) {
      $row[11] = set_new_subproject($parent);
    }
    // ... or a new project at all
   else { set_new_project(); }
  }                                                                                                                                                           

  // enable js check, begin form
  echo "<form action='projects.php' method='post' name=frm onSubmit=\"return chkForm('frm','name','$admin_text73!')\">\n";
  $hidden = array_merge(array('ID'=>$ID,'type'=>$type,'mode'=>'data','gruppe'=>'user_group','justform'=>$justform,'project_name'=>$project_name), $view_param);
  echo hidden_fields($hidden);
  build_form($fields); 
  
  // assign project to a subproject                                                                                             
  echo "<br><table><tr><td>$proj_text10:</td><td>";
  echo "<select name='parent'".read_o($read_o)."><option value=''>\n";
  // prepare query for function
  $query = "where $sql_user_group";
  // call function to show all required elements in a tree structure in the select box   
  show_elements_of_tree('projekte',
                        'name',
                        "where (acc like 'system' or ((von = ".$user_ID." or acc like 'group' or acc like '%\"$user_kurz\"%') and $sql_user_group))",
                        'acc'," order by name",$parent,'parent',$ID);  
  
  echo "</select></td></tr>\n"; 
                                       
  // show already booked work time
  if ($projekte > 1) {
    $result2 = db_query("select h,m 
                           from ".DB_PREFIX."timeproj 
                          where projekt = '$ID'") or db_die();
    while ($row2 = db_fetch_row($result2)) { $sum1 = $sum1 + $row2[0]*60+$row2[1]; }                                                                                     
    $h = floor($sum1/60);
    $m = $sum1 - $h*60;
    $amount = number_format($row[16] * $sum1/60);
    if ($amount > 0) {
      echo "<tr><td>$proj_text16: </td><td>$cur_symbol:$amount - h:$h/m:$m </td></tr>\n";
    }
  }     
  
  echo solidbar();
  
  // next record in list
  if ($ID > 0) {
    // check where there are any other projects on this level
    $result2 = db_query("select count(ID) 
                           from ".DB_PREFIX."projekte 
                          where parent = '$parent' and 
                                ID <> '$ID'") or db_die();
    $row2 = db_fetch_row($result2);
    // first display the possible modes
    if ($row2[0] > 0) {   
      echo "<tr><td>$r_bmlist:</td><td> <select name=next_mode".read_o($read_o)."><option value=0>\n";
      foreach ($next_mode_arr as $next1 => $next2) {
        echo "<option value='$next1'";
        if ($next1 == $next_mode) { echo " selected"; }
        echo ">$next2:\n";
      }
      echo "</select> \n";
      // fetch all of these neighbours and display them 
      echo "<select name=next_proj".read_o($read_o)."><option value=0>\n";
      $result2 = db_query("select ID, name 
                             from ".DB_PREFIX."projekte 
                            where parent = '$parent' and 
                                  $sql_user_group and 
                                  ID <> '$ID' 
                         order by name") or db_die();
      while ($row2 = db_fetch_row($result2)) {
        echo "<option value='$row2[0]'";
        if ($row2[0] == $next_proj) { echo " selected"; }
        echo ">$row2[1]\n";
      }
      echo "</select>\n";     
      echo"</td></tr>\n"; 
      // dependency
      echo "<tr><td>$proj_text34</td><td><select name=depend_mode".read_o($read_o)."><option value=0>\n";
      foreach ($dependencies as $dep1 => $dep2) {
        echo "<option value='$dep1'";
        if ($dep1 == $depend_mode) { echo " selected"; }
        echo ">$dep2:\n";
      }
      echo "</select>\n";
      // fetch all of these neighbours and display them 
      echo "<select name=depend_proj".read_o($read_o)."><option value=0>\n";
      $result2 = db_query("select ID, name 
                             from ".DB_PREFIX."projekte 
                            where parent = '$parent' and 
                                  $sql_user_group and 
                                  ID <> '$ID'                                                                                                                           
                         order by name") or db_die();
      while ($row2 = db_fetch_row($result2)) {
        echo "<option value='$row2[0]'";
        if ($row2[0] == $depend_proj) { echo " selected"; }
        echo ">$row2[1]\n";
      }
      echo "</select>\n";     
      echo"</td></tr>\n";            
    }
    // otherwise set the dependency to 0 to avoid that this project has an 'old' dependency
    else {
      echo "<input type=hidden name=dependency value='0'>\n";
    }   
  }
   
                                                                                                                                   
  echo "</table><br><table border=1 cellpadding=4 cellspacing=0>\n";  
   // select participants
  echo "<tr><td valign=top>$proj_pers: </td><td><select name='personen[]' multiple size='8'".read_o($read_o).">\n";
  // select user from this group
  include_once("$lib_path/show_group_users.inc.php");
  // show all members of the group, don't exclude yourself
  echo show_group_users($user_group, 0, $row[21]);
  echo "</select></td>\n"; 
  
  // access
  // relevant field in db=nr.11, exclude the user itself, field number of acc_write, no parent possible, write access=yes  
  echo "<td valign=top>$datei_text11<br>".access_form($row[22], 0, $row[23], 0, 1)."</tr></table>";
  
  echo '<br><br>'; 
  
  // ***************
  // various buttons
  echo "<table><tr>";
  // only chiefs/project leaders with write permission can modify or delete projects
  if (!$read_o and check_role("projects") > 1){ 
    if (!$ID) {
      echo "<td><input type=submit value='$admin_text6'></td>\n";
      echo "<input type=hidden name='anlegen' value='$create_it'>\n";
    } // modify and delete
    else {
      echo "<td><input type=submit value='$admin_text7'></td>\n";
      // change values
      echo "<input type=hidden name='anlegen' value='$modify_it'>\n";
      // check whether there is no subproject beyond this one. if no -> allow to delete
      $result2 = db_query("select ID 
                             from ".DB_PREFIX."projekte 
                            where parent = '$ID'") or db_die();
      $row2 = db_fetch_row($result2);
      if ($row2[0] == '') { echo "<td><input type=submit name='delete' value='$admin_text8' onClick=\"return confirm('$confirm')\"></td>\n"; }

    }
  } // end buttons chief only
  echo "</form>";  
  // new subproject
  if (!$read_o and check_role("projects") > 1 and $ID > 0){
    echo "<form action='projects.php' method='post'>\n";
    $hidden = array_merge(array('parent'=>$ID,'action'=>'new','mode'=>'forms'), $view_param);
    echo hidden_fields($hidden);
    echo "<td><input type=submit value='$proj_text15'></form></td>\n";
  }
  // cancel
  echo "<form action='projects.php' method='post'>\n";
  $hidden = array_merge(array('type'=>$type,'sort'=>$sort,'mode'=>'view','up'=>$up,'filter'=>$filter,'keyword'=>$keyword,'perpage'=>$perpage,'page'=>$page), $view_param);
  echo hidden_fields($hidden);
  echo "<td><input type=submit value='$back'></form></td>\n";  
  // print
  if ($ID > 0) { 
    echo "<form action='../misc/print.php' method='post' target=_blank>\n";
    $hidden = array_merge(array('ID'=>$row[0],'module'=>'proj'), $view_param);
    echo hidden_fields($hidden);
    echo "<td><input type=submit value='$print'></form></td>\n";   
  }
  echo "</tr></table>";
 
  echo solidbar('550');

  //*********************
  // show related objects

  if ($ID > 0) {
    $projekt_ID = $ID;
    // include the lib
    include_once("$lib_path/show_related.inc.php"); 
    $referer = "projects.php?mode=forms&ID=$ID";  
    // show related todos
    if ($todo and check_role("todo") > 0) { 
      echo "<tr><td colspan=6>\n";    
      $query = "project = '$ID'";
      show_related_todo($query,$referer); 
      echo "&nbsp;</td></tr>\n";  
      echo "<tr><td colspan=6>".solidbar(550)."</td></tr>\n";       
    }
   
    // related notes, show only for existing projects
    if ($notes and check_role("notes") > 0) { 
      echo "<tr><td colspan=6>\n";  
      $query = "projekt = '$ID'";
      show_related_notes($query,$referer); 
     echo "&nbsp;</td></tr>\n";
      echo "<tr><td colspan=6>".solidbar(550)."</td></tr>\n";     
    }
  
    // show related files
    if ($dateien and check_role("filemanager") > 0) { 
      echo "<tr><td colspan=6>\n";  
      $query = "div2 like '$ID' and 
                (von = '$user_ID' or acc like 'system' or ((acc like 'group' or acc like '%\"$user_kurz\"%') and $sql_user_group)) and 
                (typ like 'f%' or typ like 'l')";
      show_related_files($query,$referer); 
      echo "&nbsp;</td></tr>\n";  
      echo "<tr><td colspan=6>".solidbar(550)."</td></tr>\n";
    }

  
    // show related events
    if ($calendar and check_role("calendar") > 0) {
      echo "<tr><td colspan=6>\n";                                                                                    
      $query = "projekt = '$ID'";
      show_related_events($query,$referer); 
      echo "&nbsp;</td></tr>\n";  
      echo "<tr><td colspan=6>".solidbar(550)."</td></tr>\n";  
    }
  }
  // end show related objects
  // ************************

  // close big table
  echo "</table>\n";

// last but maybe not least
if ($history_log) echo history_show('projekte',$ID);  
  
// end  of big form :-)

// set variables for a new subproject
function set_new_subproject($parent) {
  global $ID, $row, $anfang, $ende;
  $result = db_query("select ID, name, anfang, ende 
                        from ".DB_PREFIX."projekte 
                       where ID = '$parent'") or db_die();
  $row = db_fetch_row($result);
  // delete ID, because it's a new project
  $row[0] = $ID = 0;
  $row[1] = "";
  $anfang = $row[2];
  $ende = $row[3];
  return $parent;
}

// set variables for a new root project
function set_new_project() {
  global $ID, $anfang, $ende, $row;
  $ID = $row[0] = 0;
  $anfang = date("Y")."-".date("m")."-".date("d");
  $ende = date("Y")."-12-31";
  $row[16] = 0;   // stundensatz / hourly rate
  $row[17] = 0;  // budget
}

// check permission: chief at all or leader of this project
function check_chief_status() {
  global $user_access, $row, $user_ID;
  if (ereg("c",$user_access) or ($row[9] == $user_ID)) return true;
  else return false;
}
?>
