<?php

// projects_view.php - PHProjekt Version 4.2
// copyright    2000-2004 Albrecht Guenther  ag@phprojekt.com
// www.phprojekt.com
// Author: Albrecht Guenther

// check whether the lib has been included - authentication!
if (!defined("lib_included")) { die("Please use index.php!"); }

// include library to sort the projects
include_once "./projects_sort.php";

// check role
if (check_role("projects") < 1) { die("You are not allowed to do this!"); }

// open and close main project
if ($element_mode == "open") {
  $arrproj[$ID] = "1";
}
elseif ($element_mode == "close"){
  $arrproj[$ID] = "";
}

// check whether a filter element should be removed
if (isset($filter_ID)) {
 unset($flist['projects'][$filter_ID]); 
 reg_sess_vars(array("flist"));
}

// set some variables
if (!$sort) { $sort = "name"; $direction="ASC"; }                                                                                                                       

// **************
// navigation bar
// first row ****
echo set_page_header();
echo "<table bgcolor=$bgcolor2 border=0><tr><td><a href='$doc/projects.html' target=_blank><b>$proj_list</b></a>&nbsp;</td>\n";
// set filter
echo "<form action='projects.php' method=post>";
if(SID) echo "<input type=hidden name='PHPSESSID' value='$PHPSESSID'>\n";
echo "<input type=hidden name='mode' value='view'>\n";
echo nav_filter($fields);

// category
echo "<td>$info_text8: <select name='category'>\n";
echo "<option value=''>\n";
foreach ($categories as $field1 => $field2) {
  echo "<option value='$field1'";
  if ($field1 == $category) { echo " selected"; }
  echo ">$field2\n";
}
echo "</select></td>\n";

// define threads/page and expanded/collapsed tree
echo "<td><input type='radio' name='tree_mode' value='open'>$forum_text10 &nbsp;";
echo "<input type='radio' name='tree_mode' value='close'>$forum_text11 &nbsp;&nbsp;|&nbsp;";
// unset the whole arary
if ($tree_mode == "close") { $arrproj = $arr_empty; }

// perpage select box
echo "<td>&nbsp;<select name='perpage'>\n";
foreach ($perpage_values as $j) {
  echo "<option value='$j'";
  if ($j == $perpage) { echo " selected"; }
  echo ">$j\n";
}
echo "</select> $items </td>\n";

// submit button
echo "<td><input type=image src='$img_path/los.gif' border=0 id=tr></td></tr></form>\n";
// end of first navigation row

// ************************
// second row of navigation
// ************************

echo "<tr><td colspan=3>\n";
// for users with chief status exclusively
if (ereg("c",$user_access) and check_role("projects") > 1) {
  // new project
  echo "<a href='projects.php?mode=forms&action=new".$sid."'>$con_text4</a> | \n";
  // options - copy or move branches
  echo "<a href='projects.php?mode=options".$sid."'>$o_opt</a> | \n";      
}
// statistics
if ($projekte > 1) { 
  echo "<a href='projects.php?mode=stat".$sid."'>$proj_stat2</a> &nbsp;| \n";                                              
  echo "<a href='projects.php?mode=stat&mode2=mystat".$sid."'>$proj_stat3</a> &nbsp;| \n";     
}
// timeline / Gantt
echo "<a href='projects.php?mode=gantt".$sid."'>$proj_text19</a>\n";

// end navigation
// define filter
// call the main filter routine 
$where = main_filter($filter,$rule,$keyword,$filter_ID,'projects');  

// define category
if ($category) { $where .= "and kategorie = $category"; }

//  define 'next' & 'previous' button, look for max number
$result = db_query("select count(ID) 
                      from ".DB_PREFIX."projekte 
                     where (acc like 'system' or ((von = $user_ID or acc like 'group' or acc like '%\"$user_kurz\"%') and $sql_user_group)) 
                           $where and 
                           (parent = '' or parent = 0)") or db_die();
$row = db_fetch_row($result);
// if no result is found, unset the last filter since apparently doesn't make any sense to keep it
if (!$row[0] and $flist['projekte'] <> '') { 
  array_splice($flist['projekte'],-1);
  echo $info_text4.'<br>'; 
}  
// show filter list and option to store selection 
if ($flist['projects']) { echo display_filters('projects'); }

if ($row[0] > $perpage) { echo "<tr>\n"; }                                                                       
$page_n = $page + 1;
$page_p = $page - 1;
// previous page
if ($page) {echo "<td><a href='projects.php?category=$category&up=$up&sort=$sort&filter=$filter&keyword=$keyword&mode=$mode&perpage=$perpage&page=$page_p$sid'>$previous</a>&nbsp;&nbsp;</td>";}
// next page
if ($row[0] > $page_n*$perpage) {
  echo "<td colspan=2><a href='projects.php?category=$category&up=$up&sort=$sort&filter=$filter&keyword=$keyword&mode=$mode&perpage=$perpage&page=$page_n$sid'>$next</a></td>\n";
}
// end navigation bar, start list
echo "</tr></table><br>\n";
echo "<table width=100% border=0 cellpadding=1 cellspacing=1>\n"; 

    // sql query
    $where = "(acc like 'system' or ((von = '$user_ID' or acc like 'group' or acc like '%\"$user_kurz\"%') and $sql_user_group))
                     $where
            order by $sort $direction";     
    build_table(array('ID','von','acc','parent'), 'projects', $where);
   // export via snippet in lib
   show_export_form("projects");  

reg_sess_vars(array("arrproj"));
?>